︠6d9e329b-84bc-45c2-956a-9d61658d353bi︠
def newton_method(f, c, eps, maxiter=100):
    x = f.variables()[0]
    fprime = f.derivative(x)
    try:
        g = f._fast_float_(x)
        gprime = fprime._fast_float_(x)
    except AttributeError:
        g = f; gprime = fprime
    iterates = [c]
    for i in xrange(maxiter):
       fc = g(c)
       if abs(fc) < eps: return c, iterates
       c = c - fc/gprime(c)
       iterates.append(c)
    return c, iterates

var('x')
html("<h1>Double Precision Root Finding Using Newton's Method</h1>")
@interact
def _(f = x^2 - 2, c = float(0.5), eps=(-3,(-16..-1)), interval=float(0.5)):
     eps = 10^(eps)
     print "eps = %s"%float(eps)
     z, iterates = newton_method(f, c, eps)
     print "root =", z
     print "f(c) = %r"%f(x=z)
     n = len(iterates)
     print "iterations =", n
     html(iterates)
     P = plot(f, (x,z-interval, z+interval), rgbcolor='blue')
     h = P.ymax(); j = P.ymin()
     L = sum(point((w,(n-1-float(i))/n*h), rgbcolor=(float(i)/n,0.2,0.3), pointsize=10) + \
             line([(w,h),(w,j)],rgbcolor='black',thickness=0.2) for i,w in enumerate(iterates))
     show(P + L, xmin=z-interval, xmax=z+interval)
︡90a4240e-baa2-4f75-aff2-d1c24dacfccc︡{"stdout":"x\n"}︡{"html":"<h1>Double Precision Root Finding Using Newton's Method</h1>"}︡{"interact":{"style":"None","flicker":false,"layout":[[["f",12,null]],[["c",12,null]],[["eps",12,null]],[["interval",12,null]],[["",12,null]]],"id":"0521cac7-de4c-458d-a9d1-662759da35d2","controls":[{"control_type":"input-box","default":"x^2 - 2","label":"f","nrows":1,"width":null,"readonly":false,"submit_button":null,"var":"f","type":null},{"control_type":"input-box","default":0.5,"label":"c","nrows":1,"width":null,"readonly":false,"submit_button":null,"var":"c","type":null},{"control_type":"slider","default":13,"var":"eps","width":null,"vals":["-16","-15","-14","-13","-12","-11","-10","-9","-8","-7","-6","-5","-4","-3","-2","-1"],"animate":true,"label":"eps","display_value":true},{"control_type":"input-box","default":0.5,"label":"interval","nrows":1,"width":null,"readonly":false,"submit_button":null,"var":"interval","type":null}]}}︡
︠5fa11478-ee32-4a6d-8350-69ec7c60f6da︠
︡1d7a833c-b7ba-4417-97a9-b4b34453c094︡
︠e3b2f49b-809e-46a4-a0a8-314ee516aabf︠
︡b6efc083-1cd9-426f-8698-0ad329ac51d1︡
︠78dbd10f-6d4a-4ad4-a932-ce14d3c2ac89︠









